var currentUser; 

firebase.auth().onAuthStateChanged(function(user) {
  if (user) {
    currentUser = user;
	try
	{
	loadDb(); // trys to load the database on firebase.
	}
	catch(err)
	{
		document.getElementById("MealList").innerText = "You Have No Meals, Add Them Through The Menu." // error message explains the user has no meals.
	}
  } else {
    // No user is signed in.
	location.href="index.html"; // if no user is signed in go to the index page.
  }
});

function loadDb()
{
	var database = firebase.database();
	var ref = database.ref('Users/' + currentUser.uid + '/Meals/'); // database refrence for the current user.
	ref.on('value', displayMeals, dataErr); // returns the data on firebase under the refrence address. if it fails is will run dataErr() and if sucessful it will call displayMeal() with the data as the parameter.
};


function displayMeals(data) // takes the firebase data as a parameter
{
	var meals = data.val(); // sets the varible meals to a object of the meals data
	if (meals!= null){ // if theres meals on the database.
	var titles = Object.keys(meals); // get the keys of each meal which is also the same as the title.
	
	for (var i =0;i<titles.length; i++) // loop through all the meals
	{
		var key = titles[i]
		document.getElementById("MealList").innerHTML += "<li>"+meals[key].title+"</li>"; // append the list on the mealspage with each meals title
	}
	}
};

	
function dataErr(err)
{
	console.log("error"); 
	console.log(err);
};

